unit MamFann;

interface

uses fann, System.Classes, System.SysUtils, VCL.Graphics,System.Types;

Type

  TMamFann=class
  private
    FFann:PFann;
    FConnectionRate: Single;//ڑ
    FLearningRate: Single;  //wK
    FLearningMomentum: Single;
    FActivationFunctionHidden:TFann_activationfunc_enum;
    FActivationFunctionOutput:TFann_activationfunc_enum;
    FTrainingAlgorithm:TFann_train_enum;

    //wK
    procedure SetLearningMomentum(Const Value: Single);
    //wK
    procedure SetLearningRate(Const Value:Single);
    //wKASY
    procedure SetTrainingAlgorithm(Const Value:TFann_train_enum);
    //\C[̃ANeBx[V֐ݒ
    procedure SetActivationFunctionHidden(Const Value: TFann_activationfunc_enum);
    //o͑w̃ANeBx[V֐ݒ
    procedure SetActivationFunctionOutput(Const Value: TFann_activationfunc_enum);

  protected
  public
    //RXgX^[(ڑ,ew̃j[)
    //  ڑ:
    //    1ƊSɐڑꂽlbg[N(fann_create_standard_array)
    //    1ƊSɐڑȂlbg[N(fann_create_sparse_array)
    //  ew̃j[:ew̃j[^
    constructor Create(NeuronNumInLayer: array of Cardinal;
      ConnectionRate:Single=1.0);overload;
    //RXgN^[(t@C)
    //  fann_create_from_filegpꍇ
    constructor Create(LoadFromFileName:String);overload;
    destructor Destroy();override;
    //덷U̎擾
    function GetMSE():Single;
    //덷ŨZbg
    procedure ResetMse();
    //g[jO
    procedure Train(Inputs,Outputs: array of TFann_type);
    procedure TrainOnFile(FileName: String; MaxEpochs: Cardinal; DesiredError: Single);
    //ANNs
    procedure Run(Inputs: array of TFann_type; var Outputs: array of TFann_type);

    procedure SaveToFile(FileName: String);
    //t@CANNǂݍ
    procedure LoadFromFile(Filename: string);
    //lbg[Nڑ擾
    function GetTotalConnections():Cardinal;
    //lbg[Nڑ擾
    procedure GetConnectionArray(pcns:PFann_Connection);
    //C[̐擾
    function GetNumLayers():Cardinal;
    procedure GetLayerArray(pc:PCardinal);
    //oCAX擾
    procedure GetBiasArray(pc:PCardinal);
    //j[lbg[N}̍쐬
    procedure CreateNeuronBmp(bmp:TBitmap);
    function GetTrainingAlgorithm():Cardinal;
    //wK(ftHg0.0A^ꍇ0.9x炵)
    property LearningMomentum:Single
      read FLearningMomentum write SetLearningMomentum;
    property LearningRate:single
      read FLearningRate write SetLearningRate;
    property TrainingAlgorithm:TFann_train_enum
      read FTrainingAlgorithm write SetTrainingAlgorithm;
    property ActivationFunctionHidden:TFann_activationfunc_enum
      read FActivationFunctionHidden write setActivationFunctionHidden;
    property ActivationFunctionOutput:TFann_activationfunc_enum
      read FActivationFunctionOutput write setActivationFunctionOutput;
  end;

implementation

{ TMamFann }

constructor TMamFann.Create(
  NeuronNumInLayer: array of Cardinal;ConnectionRate:Single=1.0);
var LayerNum: Cardinal; //C[̐
begin
  if Length(NeuronNumInLayer)<2 then
    raise Exception.Create('QC[ȏオKvł');
  FConnectionRate  :=ConnectionRate;//ڑ
  FLearningRate    :=0.7;//wK
  FLearningMomentum:=0.0;//wK
  //SĂ̔\C[̃ANeBx[V֐̐ݒ
  FActivationFunctionHidden:=TFann_activationfunc_enum.FANN_SIGMOID;
  //SĂ̏o̓C[̃ANeBx[V֐̐ݒ
  FActivationFunctionOutput:=TFann_activationfunc_enum.FANN_SIGMOID;
  //KASY
  FTrainingAlgorithm:=TFann_train_enum.FANN_TRAIN_RPROP;
  LayerNum:=Length(NeuronNumInLayer);

  if(FConnectionRate<1) then
    FFann:=fann_create_sparse_array(
      FConnectionRate,LayerNum,@NeuronNumInLayer[0])
  else
    FFann:=fann_create_standard_array(LayerNum,@NeuronNumInLayer[0]);

  fann_randomize_weights(FFann,-0.5,0.5);
  fann_set_learning_rate(FFann,FLearningRate);
  fann_set_learning_momentum(FFann,FLearningMomentum);
  fann_set_activation_steepness_hidden(FFann,0.5);
  fann_set_activation_steepness_output(FFann,0.5);
  fann_set_activation_function_hidden(
    FFann,Cardinal(ord(FActivationFunctionHidden)));
  fann_set_activation_function_output(
    FFann,Cardinal(ord(FActivationFunctionOutput)));
  fann_set_training_algorithm(
    FFann,Cardinal(ord(FTrainingAlgorithm)));

  self.ResetMse;
end;

constructor TMamFann.Create(LoadFromFileName: String);
begin
  self.LoadFromFile(LoadFromFileName);
end;

procedure TMamFann.CreateNeuronBmp(bmp: TBitmap);
//j[lbg[N}̍쐬
Type
  TNeuron=record
    x,y:integer;
    isBias:Boolean;
  end;
var ConnectionNum: Cardinal;//lbg[N̐ڑ
    Connections: array of TFann_Connection;//lbg[N̐ڑ
    LayerNum: Cardinal;//C[(w)
    NeuronNums:array of Cardinal; //eC[(w)Ƃ̃j[
    BiasNums:array of Cardinal;   //eC[(w)Ƃ̃oCAX̐
    Neurons:array of TNeuron;
    NeuronCount:integer;
    i,j:integer;
    max_x,max_y:integer;
    FromPoint,ToPoint:TPoint;
    ConWeight:integer;
    ConColor:TColor;
const
  span:integer=100;
begin
  //lbg[N̐ڑ擾
  ConnectionNum:=Self.GetTotalConnections();
  SetLength(Connections,ConnectionNum);
  //lbg[N̐ڑ擾܂
  Self.GetConnectionArray(@Connections[0]);

  //C[̎擾(oCAX܂܂)
  LayerNum:=Self.GetNumLayers();
  SetLength(NeuronNums, LayerNum);
  SetLength(BiasNums  , LayerNum);
  //eC[̃j[擾(oCAX܂܂)
  Self.GetLayerArray(@NeuronNums[0]);
  //eC[̃oCAX擾
  Self.GetBiasArray(@BiasNums[0]);

  NeuronCount:=0;
  for i := 0 to LayerNum-1 do
  begin
    for j := 0 to NeuronNums[i]-1 do
    begin
      inc(NeuronCount);
      setLength(Neurons,NeuronCount);
      Neurons[NeuronCount-1].x:=j;
      Neurons[NeuronCount-1].y:=i;
      Neurons[NeuronCount-1].isBias:=false;
    end;
    for j := 0 to BiasNums[i]-1 do
    begin
      inc(NeuronCount);
      setLength(Neurons,NeuronCount);
      Neurons[NeuronCount-1].x:=NeuronNums[i]+j;
      Neurons[NeuronCount-1].y:=i;
      Neurons[NeuronCount-1].isBias:=True;
    end;
  end;

  max_y:=LayerNum;
  max_x:=0;
  for i := 0 to Length(Neurons)-1 do
  begin
    if max_x<Neurons[i].x then
      max_x:=Neurons[i].x;
  end;
  inc(max_x);
  if not Assigned(bmp) then
    bmp:=TBitmap.Create;

  bmp.Width :=max_x*span;
  bmp.Height:=max_y*span;

  bmp.Canvas.Brush.Color:=$FFFFFF;
  bmp.Canvas.Brush.Style:=TBrushStyle.bsSolid;
  bmp.Canvas.FillRect(Rect(0,0,bmp.Width,bmp.Height));

  for i := 0 to ConnectionNum-1 do
  begin
    FromPoint.X:=Neurons[Connections[i].from_neuron].x;
    FromPoint.Y:=Neurons[Connections[i].from_neuron].y;
    ToPoint.X  :=Neurons[Connections[i].to_neuron].x;
    ToPoint.Y  :=Neurons[Connections[i].to_neuron].y;
    ConWeight  :=trunc(Connections[i].weight);
    if ConWeight>0 then
      ConColor:=$000000
    else
      ConColor:=$0000FF;
    ConWeight:=ABS(ConWeight);
    if ConWeight=0 then ConWeight:=1;
    bmp.Canvas.Pen.Color:=ConColor;
    bmp.Canvas.Pen.Width:=ConWeight;
    bmp.Canvas.MoveTo(
      FromPoint.X*span + span div 2, FromPoint.Y*span + span div 2);
    bmp.Canvas.LineTo(
      ToPoint.X  *span + span div 2, ToPoint.Y  *span + span div 2);
  end;
  for i := 0 to NeuronCount-1 do
  begin
    if Neurons[i].isBias then
      ConColor:=$0099FF
    else
      ConColor:=$FF0000;

    bmp.Canvas.Pen.Color:=ConColor;
    bmp.Canvas.Brush.Color:=ConColor;
    bmp.Canvas.Ellipse(
      Neurons[i].x*span + span div 2 - span div 8,
      Neurons[i].y*span + span div 2 - span div 8,
      Neurons[i].x*span + span div 2 + span div 8,
      Neurons[i].y*span + span div 2 + span div 8
    );
  end;
end;

destructor TMamFann.Destroy;
begin
  fann_destroy(FFann);
  inherited;
end;


procedure TMamFann.GetBiasArray(pc: PCardinal);
begin
  fann_get_bias_array(FFann,pc);
end;

procedure TMamFann.GetConnectionArray(pcns: PFann_Connection);
begin
  fann_get_connection_array(FFann,pcns);
end;

procedure TMamFann.GetLayerArray(pc: PCardinal);
begin
  fann_get_layer_array(FFann,pc);
end;

function TMamFann.GetMSE: Single;
begin
  result:=fann_get_MSE(FFann);
end;

function TMamFann.GetNumLayers: Cardinal;
begin
  result:=fann_get_num_layers(FFann);
end;

function TMamFann.GetTotalConnections: Cardinal;
begin
  result:=fann_get_total_connections(FFann);
end;

function TMamFann.GetTrainingAlgorithm: Cardinal;
begin
  result:=fann_get_training_algorithm(FFann);
end;

procedure TMamFann.LoadFromFile(Filename: string);
begin
  if Assigned(FFann) then
    fann_destroy(FFann);
  FFann:=fann_create_from_file(PAnsiChar(AnsiString(Filename)));
end;

procedure TMamFann.ResetMse;
begin
  fann_reset_mse(FFann);
end;

procedure TMamFann.Run(
  Inputs: array of TFann_type;var Outputs: array of TFann_type);
var out_array: Pfann_type_array;
    i: Integer;
begin
  out_array:=fann_run(FFann,@Inputs[0]);
  for i:=0 to High(outputs) do
  begin
    Outputs[i]:=out_array[i];
  end;
end;

procedure TMamFann.SaveToFile(FileName: String);
begin
  fann_save(FFann,PAnsiChar(AnsiString(Filename)));
end;

procedure TMamFann.SetActivationFunctionHidden(
  const Value: TFann_activationfunc_enum);
begin
  FActivationFunctionHidden:=Value;
  fann_set_activation_function_hidden(
    FFann,Cardinal(ord(FActivationFunctionHidden)));
end;

procedure TMamFann.SetActivationFunctionOutput(
  const Value: TFann_activationfunc_enum);
begin
  FActivationFunctionOutput := Value;
  fann_set_activation_function_output(
    FFann,Cardinal(ord(FActivationFunctionOutput)));
end;

procedure TMamFann.SetLearningMomentum(const Value: Single);
begin
  FLearningMomentum:=Value;
  fann_set_learning_momentum(FFann,FLearningMomentum);
end;

procedure TMamFann.SetLearningRate(const Value: Single);
begin
  FLearningRate:=Value;
  fann_set_learning_rate(FFann,FLearningRate);
end;

procedure TMamFann.SetTrainingAlgorithm(const Value: TFann_train_enum);
begin
  FTrainingAlgorithm:=Value;
  fann_set_training_algorithm(
    FFann,Cardinal(ord(FTrainingAlgorithm)) );
end;

procedure TMamFann.Train(Inputs,Outputs: array of TFann_type);
begin
  fann_train(FFann, @Inputs[0], @Outputs[0]);
end;

procedure TMamFann.TrainOnFile(FileName: String; MaxEpochs: Cardinal;
  DesiredError: Single);
begin
  fann_train_on_file(
    FFann,PAnsiChar(AnsiString(FileName)),MaxEpochs,1000,DesiredError);
end;

end.
